/* SCCS  %W% - %G% - %U% */

/* Copyright 1999 University of Southern California Brain Lab */
/* email nsl@java.usc.edu */

nslModule BPError (int outSize) 
{
    public NslDinFloat1 yo(outSize);      
    public NslDinFloat1 t(outSize);  
    
    public NslDoutFloat1 err(outSize);      

    private NslFloat0 epsilon();      
    public  NslFloat0 tss();
        
    public void initTrain() {
        tss = 0.0;
    }

    public void simTrain() {
        err = t - yo;
        tss = tss + (float)nslSum(err ^ err);
    }

    public void endTrain() {
        if (tss < epsilon) {
            nslPrintln("Convergence");
            system.breakEpochs();
        }
    }
}
